-- zfill.e
-- filling routines for the ZIG Editor

constant XF = 1, YF = 2

global procedure FillArea(sequence seedcoords, sequence source, sequence ground, atom board, atom layer)

    atom fill_done, cx, cy, kill, k
    sequence nodes

    nodes = {{0, 0}}

    fill_done = 0

    nodes[1] = seedcoords

    while not fill_done do
        k = get_key()
        if k != -1 then fill_done = 1 end if
        position(1, 1) ?length(nodes)
        for z = length(nodes) to length(nodes) do
            kill = 1
            if length(nodes) = 0 then
                fill_done = 1
                exit
            end if
            cx = nodes[z][XF]
            cy = nodes[z][YF]
            if cx > 1 then 
                if Boards[board][BoardI(cx-1, cy, layer, 1)] = ground[1]
                and Boards[board][BoardI(cx-1, cy, layer, 2)] = ground[2]
                and Boards[board][BoardI(cx-1, cy, layer, 3)] = ground[3]
                then
                    nodes = append(nodes, {cx - 1, cy})
                    kill = 0
                else kill = 1
                end if
            end if
            if cy > 1 then
                if Boards[board][BoardI(cx, cy-1, layer, 1)] = ground[1]
                and Boards[board][BoardI(cx, cy-1, layer, 2)] = ground[2]
                and Boards[board][BoardI(cx, cy-1, layer, 3)] = ground[3]
                then
                    nodes = append(nodes, {cx, cy - 1})
                    kill = 0
                else kill = 1
                end if
            end if
            if cx < 25 then
                if Boards[board][BoardI(cx+1, cy, layer, 1)] = ground[1]
                and Boards[board][BoardI(cx+1, cy, layer, 2)] = ground[2]
                and Boards[board][BoardI(cx+1, cy, layer, 3)] = ground[3]
                then
                    nodes = append(nodes, {cx + 1, cy})
                    kill = 0
                else kill = 1
                end if
            end if
            if cy < 60 then                                
                if Boards[board][BoardI(cx, cy+1, layer, 1)] = ground[1]
                and Boards[board][BoardI(cx, cy+1, layer, 2)] = ground[2]
                and Boards[board][BoardI(cx, cy+1, layer, 3)] = ground[3]
                then
                    nodes = append(nodes, {cx, cy + 1})
                    kill = 0
                else kill = 1
                end if
            end if
        
            if z = 1 then
                nodes = nodes[2..length(nodes)]
            elsif z = length(nodes) then
                nodes = nodes[1..length(nodes) - 1]
            else
                nodes = nodes[1..z - 1] & nodes[z + 1..length(nodes)]
            end if
            position(cx, cy)
            text_color(source[3])
            puts(1, source[2])
            Boards[board][BoardI(cx, cy, layer, 1)] = source[1]
            Boards[board][BoardI(cx, cy, layer, 2)] = source[2]
            Boards[board][BoardI(cx, cy, layer, 3)] = source[3]
        end for
    end while
end procedure

