-- zgui.e
-- ZIG GUI functions
-- all messy and goofed up for now...

include file.e
include machine.e
include image.e
include graphics.e
include get.e
include misc.e

include zutil.e
include zgfx.e

global atom
            Scroll_SizeX, Scroll_SizeY, Scroll_TextC, Scroll_BackC,
            Scroll_PosX, Scroll_PosY, Scroll_HLTitleC, Scroll_BorderC


global function DisplayScroll(sequence Caption, sequence Scroll, atom Sel)
    atom X, PutX, OldX, Key
    sequence TxtScr

    TxtScr = save_text_image({1, 1}, {25, 80})
    cursor(NO_CURSOR)
    
    text_color(14)
    bk_color(1)
    
    Box(Scroll_PosX,
        Scroll_PosY,
        (Scroll_PosX - 1) + Scroll_SizeX,
        (Scroll_PosY - 1) + Scroll_SizeY,
        Scroll_BackC,
        Caption)

    if Sel then X = Sel else X = 1 end if
    bk_color(Scroll_BackC)
    
    text_color(Scroll_HLTitleC)
    position(Scroll_PosX + (Scroll_SizeX / 2), Scroll_PosY)
    puts(1, "")
    position(Scroll_PosX + (Scroll_SizeX / 2), Scroll_PosY + Scroll_SizeY - 1)
    puts(1, "")

    Key = -2
    while Key != 27 and Key != 13 do
    
        if Key = -2 then OldX = 0 else OldX = X end if
        
        Key = get_key()
        if Key != -1 then
            if Key = KEY_UP then
                X = X - 1
            elsif Key = KEY_DN then
                X = X + 1
            elsif Key = KEY_PGUP then
                X = X - (Scroll_SizeX - 3)
            elsif Key = KEY_PGDN then
                X = X + (Scroll_SizeX - 3)
            end if
        end if
        
        if X != OldX then
            if X < 1 then
                X = 1
            elsif X > length(Scroll) then
                X = length(Scroll)
            end if
            if X != OldX then
                X = X + 1
                text_color(Scroll_TextC)    
                for z = 1 to Scroll_SizeX - 2 do
                    PutX = (z - (Scroll_SizeX / 2)) + (X - 1)
                    if PutX > 0 and PutX < (length(Scroll) + 1) then                        
                        position(Scroll_PosX + z, Scroll_PosY + 1)
                        if length(Scroll[PutX]) != 0 then
                            if Scroll[PutX][1] = '$' then
                                puts(1, repeat(32, Scroll_SizeY - 2))
                                position(Scroll_PosX + z, (Scroll_PosY + ((Scroll_SizeY / 2) - (length(Scroll[PutX]) / 2))) + 1)
                                text_color(Scroll_HLTitleC)                            
                                puts(1, Scroll[PutX][2..length(Scroll[PutX])])
                                text_color(Scroll_TextC)                            
                            elsif Scroll[PutX][1] = '!' then
                                puts(1, repeat(32, Scroll_SizeY - 2))
                                if z = (Scroll_SizeX / 2) then
                                    text_color(Scroll_TextC)
                                else text_color(Scroll_BorderC)
                                end if
                                position(Scroll_PosX + z, Scroll_PosY + 1)
                                puts(1, "  ")
                                text_color(Scroll_HLTitleC)
                                puts(1, Scroll[PutX][find(';', Scroll[PutX]) + 1..length(Scroll[PutX])])
                            else
                                text_color(Scroll_TextC)
                                puts(1, Scroll[PutX])
                                puts(1, repeat(32, (Scroll_SizeY - 2) - length(Scroll[PutX])))
                            end if
                        else
                            puts(1, repeat(32, Scroll_SizeY - 2))
                        end if
                    elsif PutX = 0 or PutX = (length(Scroll) + 1) then
                        position(Scroll_PosX + z, Scroll_PosY + 1)
                        text_color(Scroll_BorderC)
                        puts(1, repeat('*', Scroll_SizeY - 2))
                        text_color(Scroll_TextC)
                    else
                        position(Scroll_PosX + z, Scroll_PosY + 1)
                        puts(1, repeat(32, Scroll_SizeY - 2))
                    end if
                end for
                X = X - 1
                --position(Scroll_PosX, Scroll_PosY + (Scroll_SizeY - 6))
                --printf(1, "%3d", X)
            end if
        end if
    end while
    
    clear_keys()
    display_text_image({1, 1}, TxtScr)

    if Key = 27 then return {} end if
    
    OldX = (Scroll_SizeX / 2)
    PutX = (OldX - (Scroll_SizeX / 2)) + X
    if length(Scroll[PutX]) != 0 then
        if Scroll[PutX][1] = '!' then
            return(Scroll[PutX][2..(find(';', Scroll[PutX]) - 1)])        
        else return {}
        end if
    else return {}
    end if
end function

procedure EditPal_bars(sequence C)
    text_color(15)
    for z = 1 to 3 do
        position(8 + z, 25)
        bk_color(0)
        puts(1, repeat(196, C[z] / 2))
        bk_color(1)
        puts(1, ' ')
        position(8 + z, 55)
        printf(1, "%3d", C[z])
    end for
end procedure

procedure EditPal_rbars()
    text_color(15)
    for z = 1 to 3 do
        position(8 + z, 25)
        bk_color(1)
        puts(1, repeat(32, 32))
        position(8 + z, 52)
        printf(1, "   ", {})
    end for
end procedure

global function EditPal(object Pal)
    atom C, oC, k, f
    sequence CurC, fn
    object ju
    
    C = 1
    CurC = get_palette(C)
    if sequence(Pal) then
        if length(Pal) = 15 then
            CurC = Pal
            ZIGSwitchPal(CurC)
        end if
    end if
        
    Box(7, 2, 16, 59, 1, "Palette Editor")
    text_at(9, 4, "Color: " & sprint(C), 15)
    Box(10, 4, 13, 8, 0, "")
    display_text_image({11, 5}, repeat({219,C,219,C,219,C}, 2))
    display_text_image({15, 4}, {{32,0,219,1,219,2,219,3,219,4,219,5,219,6,219,7,219,8,219,9,219,10,219,11,219,12,219,13,219,14,219,15,32,0}})
    bk_color(1)
    text_at(9, 15, "R/r - red", 15)
    text_at(10, 15, "G/g - grn", 15)
    text_at(11, 15, "B/b - blu", 15)
    text_at(13, 15, "+/- - change current color", 15)
    text_at(15, 25, "Enter/ESC - exit  S/L - save/load", 15)
    
    EditPal_bars(CurC)
    
    while 1 do
        oC = C
        k = get_key()
        if k = 'R' then
            if CurC[1] <= 63 then CurC[1] = CurC[1] + 1 oC = -1 end if
        elsif k = 'r' then
            if CurC[1] > 0 then CurC[1] = CurC[1] - 1 oC = -1 end if
        elsif k = 'G' then
            if CurC[2] <= 63 then CurC[2] = CurC[2] + 1 oC = -1 end if
        elsif k = 'g' then
            if CurC[2] > 0 then CurC[2] = CurC[2] - 1 oC = -1 end if
        elsif k = 'B' then
            if CurC[3] <= 63 then CurC[3] = CurC[3] + 1 oC = -1 end if
        elsif k = 'b' then
            if CurC[3] > 0 then CurC[3] = CurC[3] - 1 oC = -1 end if
        elsif k = 27 then
            fn = {}
            for z = 0 to 15 do
                fn = append(fn, get_palette(z))
            end for
            return(fn)
        elsif k = '+' or k = '=' then
            if C < 15 then C = C + 1 end if
            CurC = get_palette(C)
            EditPal_rbars()
        elsif k = '-' or k = '_' then
            if C > 0 then C = C - 1 end if
            CurC = get_palette(C)
            EditPal_rbars()
        elsif k = 'S' or k = 's' then
            fn = SB_Input(SBI_FILENAME, 20, "Filename?.ZPL", 8)
            fn = fn & ".zpl"
            f = open(fn, "w")
            ju = {}
            for z = 0 to 15 do
                ju = append(ju, get_palette(z))
            end for
            print(f, ju)
            close(f)
        elsif k = 'L' or k = 'l' then
            fn = SB_Input(SBI_FILENAME, 20, "Filename?.ZPL", 8)
            fn = fn & ".zpl"
            if not atom(dir(fn)) then
                f = open(fn, "r")
                CurC = get(f)
                CurC = CurC[2]
                ZIGSwitchPal(CurC)
                close(f)
            end if
        end if
        
        if C != oC then            
            if oC != -1 then
                text_at(9, 4, "Color: " & sprint(C) & " ", 15)
                Box(10, 4, 13, 8, 0, "")
                display_text_image({11, 5}, repeat({219,C,219,C,219,C}, 2))
            end if
            EditPal_bars(CurC)
            set_palette(C, CurC)
        end if            
    end while
end function

global function GetBoard(atom Sel)
    sequence BScroll                                    -- !
    sequence BName                                      --   !
    BScroll = {}                                        --  !
                                                        --    !
    for z = 1 to length(Boards) do                      --   !
        if length(BoardProps[z][BP_NAME]) != 0 then     -- bill was
            BName = BoardProps[z][BP_NAME]              --    !  here! (:cB){
        else
            -- BName = "Untitled Board"
            BName = "Untitled Board (#" & num2str(z) & ")"
            -- /\ used to causes wierd flake error
            -- seems to work OK now, was a problem with num2str() fixed!
        end if
        BScroll = append(BScroll, "!" & z + 15 & ";" & BName)
    end for
        
    BScroll = append(BScroll, "!" & 9999 & ";Add new board")    
    
    BName = DisplayScroll("Choose a Board", BScroll, Sel)
    
    if length(BName) = 0 then
        return(0)
    end if

    if BName[1] != 9999 then
        return(BName[1] - 15)
    else return(9999)
    end if
end function

global procedure DrawProp(atom x, sequence Title, sequence V, atom Type, atom S)
    object Value
    
    Value = V
    
    if S then
        text_color(15)
        bk_color(0)
    else
        text_color(14)
        bk_color(1)
    end if
    
    position(x, 7)
    puts(1, Title)
    position(x, 27)
    if Type = WBP_STRING then
        puts(1, Value)
    elsif Type = WBP_BOARD then
        if sequence(Value) then
            if length(Value) != 0 then
                Value = Value[1]
            else Value = -1
            end if
        end if
        if Value >= 1 then
            if compare(BoardProps[Value][BP_NAME], {}) != 0 then
                puts(1, BoardProps[Value][BP_NAME])
            else
                printf(1, "Untitled Board (%d)", Value)
            end if
        else
            puts(1, "(no board selected)")
        end if
    elsif Type = WBP_NUMBER then
        printf(1, "%d", Value[1])
    end if
end procedure

function GetPropInput(atom x, sequence O, atom t)
    object Old
    
    Old = O
    
    position(x, 27)
    text_color(15)
    bk_color(0)
    
    if t = WBP_STRING then
        puts(1, repeat(' ', 20))
        position(x, 27)
        Old = gets(0)
        Old = Old[1..length(Old) - 1]
        position(x, 27)
        bk_color(1)
        puts(1, repeat(' ', 20))
    elsif t = WBP_BOARD then
        if length(Old) = 0 then
            Old = {1}
        end if
        Old = Old[1]
        Old = GetBoard(Old)
        if Old = 9999 then
            Old = 1
        end if
        Old = {Old}
        position(x, 27)
        bk_color(1)
        puts(1, repeat(' ', 20))
    elsif t = WBP_NUMBER then
        puts(1, repeat(' ', 20))
        position(x, 27)
        Old = get(0)
        Old = Old[1]
        Old = {Old}
        position(x, 27)
        bk_color(1)
        puts(1, repeat(' ', 20))
    elsif t = WBP_PALETTE then
        Old = EditPal(Old)
    elsif t = WBP_CHARSET then
        if length(Old) != 0 then
            CharSet = Old
            add_all_fonts(0, CharSet)
        end if
        EditChars()
        Old = CharSet
    end if
    
    return Old
end function

global function GetProps(sequence PropData, sequence ExsProps, sequence Cap, atom B)
    atom k, x, xo
    sequence SS
    
    SS = SaveScreen()
    
    Box(2, 5, 24, 55, 1, Cap)
    text_color(14)
    for z = 1 to length(PropData) do
        DrawProp(3 + z, PropData[z][1], ExsProps[z], PropData[z][2], 0)
    end for
    
    x = 1
    xo = 999
    while TRUE do
        if xo != 999 then xo = x end if
         
        k = get_key()
        if k = KEY_UP then
            x = x - 1
        elsif k = KEY_DN then
            x = x + 1
        elsif k = KEY_CR then
            ExsProps[x] = GetPropInput(3 + x, ExsProps[x], PropData[x][2])
            xo = 999
        elsif k = KEY_ESC then
            exit
        end if
        
        if x != xo then
            if xo = 999 then xo = x end if
            if x < 1 or x > length(PropData) then
                x = xo
            end if
            DrawProp(3 + xo, PropData[xo][1], ExsProps[xo], PropData[xo][2], 0)
            DrawProp(3 + x, PropData[x][1], ExsProps[x], PropData[x][2], 1)
        end if
    end while

    ResScreen(SS)
    
    return ExsProps
end function

global function GetProps_DisabledMsg(sequence ExsProps, sequence PropData, sequence Cap, atom B)
    atom Joe
    sequence SS
    
    SS = SaveScreen()

    Box(6, 5, 15, 55, 1, "World/Board Properties Not Supported")
                
    position(8, 7)
    text_color(14)
    bk_color(1) 
    
    puts(1, "Sorry, this version of the ZIG editor doesn't")
    position(9, 7)
    puts(1, "support World or Board property modification.")
    position(10, 7)
    puts(1, "Properties have been incorporated into the")
    position(11, 7)
    puts(1, "world file format, however.")
    
    text_color(15)
    position(13, 7)
    puts(1, "Press any key to continue...")
    
    Joe = wait_key()
    ResScreen(SS)
    return(ExsProps)
    
    if not B then
        for z = 1 to length(PropData) do
            puts(1, PropData[z][1] & "? ")
            if PropData[z][2] != 1 then
                ExsProps[z] = str2num(gets(0))
            else
                ExsProps[z] = gets(0)
            end if
        end for
    else
        for z = 1 to length(PropData) do
            puts(1, PropData[z][1] & "? ")
            if PropData[z][2] != 1 then
                ExsProps[B][z] = str2num(gets(0))
            else
                ExsProps[B][z] = gets(0)
            end if            
        end for
    end if
    
    ResScreen(SS)
    cursor(NO_CURSOR)    
    return(ExsProps)
end function

global function GetChar_OldGetChar(atom OrigChar)
    sequence Draw, Counter, SS
    
    Draw = repeat(repeat(0, 64), 8)
    OrigChar = 0 -- suppress warning
    
    SS = SaveScreen()

    position(21, 62)
    text_color(14)
    bk_color(1)
    puts(1, "Character?")
    position(22, 62)
    text_color(15)
    bk_color(0)
    puts(1, "   ")
    cursor(UNDERLINE_CURSOR)

    position(22, 62)
    Counter = gets(0)
    if length(Counter) != 1 then
        Counter = Counter[1..length(Counter) - 1]       -- Remove trailing CR
    end if
    
    cursor(NO_CURSOR)
    
    ResScreen(SS)
    return(str2num(Counter))
end function

global function GetChar(atom OriChar)
    atom Counter, CChar, KRef, Cx, Cy, OldX, OldY, OChar, Input, OrigChar
    sequence Draw, SS
    
    SS = SaveScreen()
    OrigChar = OriChar
    OrigChar = 0    -- bug fixer

    Draw = repeat(repeat(0, 64), 8)
    
    Box(7, 2, 16, 59, 1, "Choose a Character")
    Counter = 0
    
    for x = 0 to 7 do
        for y = 0 to 63 by 2 do
            Draw[x + 1][y + 1] = Counter
            Draw[x + 1][y + 2] = 15
            if Counter = OrigChar then
                Cx = x
                Cy = y
            end if
            Counter = Counter + 1
        end for
    end for
    
    display_text_image({8, 3}, Draw)    
    
    color(14, 1)    
    position(14, 36)
    puts(1, "Enter - Accept")
    position(15, 36)
    puts(1, "  ESC - Cancel")    
    
    OldX = Cx
    OldY = Cy
    KRef = ON
    CChar = OrigChar
    
    while TRUE do
                        
        Input = get_key()

        OldX = Cx
        OldY = Cy
        OChar = CChar
        
        if Input = KEY_UP then
            Cx = Cx - 1
            CChar = CChar - 32
        elsif Input = KEY_DN then
            Cx = Cx + 1
            CChar = CChar + 32
        elsif Input = KEY_LF then
            Cy = Cy - 1
            CChar = CChar - 1
        elsif Input = KEY_RT then
            Cy = Cy + 1
            CChar = CChar + 1
        elsif Input = KEY_CR then
            ResScreen(SS)
            return CChar
        elsif Input = KEY_ESC then
            if OrigChar != 0 then
                ResScreen(SS)
                return OrigChar
            end if
        end if
        
        if Cx != OldX or Cy != OldY or KRef = ON then
            
            KRef = OFF
            
            if Cx < 0 or Cx > 7 then
                Cx = OldX
                CChar = OChar
            end if
            if Cy < 0 or Cy > 31 then
                Cy = OldY
                CChar = OChar
            end if

            display_text_image({OldX + 8, OldY + 3}, {{OChar, 15}})
            
            color(14, 0)
            position(Cx + 8, Cy + 3)
            puts(1, 197)
            
            color(14, 1)
            position(8, 36)
            puts(1, "In Current Color: ")
            color(15, 1)
            position(9, 36)
            puts(1, "Char Number: ")
            printf(1, "%3d  ", CChar)
            color(CColorF, CColorB)
            
            display_text_image({8, 54}, {{CChar, ColAttrib(CColorF, CColorB)}})
        end if
    end while
end function

global procedure ColorDialog()
    atom Cx, Cy, KRef, OldX, OldY, Input
    sequence Draw, SS
    Draw = repeat(repeat(0, 32), 16)
    
    SS = SaveScreen()
    Box(3, 10, 20, 50, 1, "Choose a Color")
    
    for x = 0 to 15 do
        for y = 0 to 15 do
            Draw[y + 1][((x + 1) * 2) - 1] = 254
            Draw[y + 1][(x + 1) * 2] = ColAttrib(x, y)
        end for
    end for
    
    display_text_image({4, 11}, Draw)
    
    Box(4, 28, 6, 38, 0, "Sample:")
    
    color(14, 1)
    position(8, 28)
    puts(1, "Enter - Accept")
    position(9, 28)
    puts(1, "  ESC - Cancel")
        
    KRef = ON
    
    Cx = CColorB
    Cy = CColorF
    
    while TRUE do
        
        Input = get_key()
        
        OldX = Cx
        OldY = Cy
        
        if Input = KEY_UP then
            Cx = Cx - 1
        elsif Input = KEY_DN then
            Cx = Cx + 1
        elsif Input = KEY_LF then
            Cy = Cy - 1
        elsif Input = KEY_RT then
            Cy = Cy + 1
        elsif Input = KEY_CR then
            CColorF = Cy
            CColorB = Cx
            CColor = ColAttrib(CColorF, CColorB)
            ResScreen(SS)
            SB_M_DrawCol(CColor)
            return
        elsif Input = KEY_ESC then
            ResScreen(SS)
            return
        end if
        
        if Cx != OldX or Cy != OldY or KRef = ON then
            KRef = OFF
            if Cx < 0 or Cx > 15 then
                Cx = OldX
            end if
            if Cy < 0 or Cy > 15 then
                Cy = OldY
            end if
            color(OldY, OldX)
            position(OldX + 4, OldY + 11)
            puts(1, 254)
            color(15, 0)
            position(Cx + 4, Cy + 11)
            puts(1, 197)
            color(Cy, Cx)
            position(5, 29)
            puts(1, 219)
            puts(1, 178)
            puts(1, 177)
            puts(1, 176)
            puts(1, "  ")
        end if
    end while
end procedure

global function ModifyObjectProps(sequence Object, sequence Lib)
    atom n
    sequence nn
    
    n = 0
    
    SB_Clear()
    Box(4, 61, 21, 80, 1, Lib[LIB_CLASS] & ":" & Lib[LIB_NAME])
    
    text_color(14)
    for z = 1 to length(Lib[LIB_PROPS]) do
        position(3 + (z * 3), 63)
        puts(1, Lib[LIB_PROPS][z][PROP_NAME])
    end for
    
    for z = 1 to length(Lib[LIB_PROPS]) do
        position(3 + (z * 3), 63)
        text_color(15)
        bk_color(1)
        puts(1, Lib[LIB_PROPS][z][PROP_NAME] & "?")
        text_color(14)
        position((3 + (z * 3)) + 1, 63)
        if Lib[LIB_PROPS][z][PROP_TYPE] = CHOOSE_NUM then
            bk_color(0)
            puts(1, "   ")
            bk_color(1)
            printf(1, " (max: %3d)", Lib[LIB_PROPS][z][PROP_MAX])
            while TRUE do
                cursor(UNDERLINE_CURSOR)
                position((3 + (z * 3)) + 1, 63)
                nn = gets(0)
                n = str2num(nn[1..length(nn) - 1])
                if Lib[LIB_PROPS][z][PROP_MAX] >= n then
                    position((3 + (z * 3)) + 1, 63)
                    bk_color(1)
                    if n = 0 then
                        n = 1
                    end if
                    printf(1, "%3d", n)
                    Object[1][OBJ_PROPS + (z - 1)] = n
                    exit
                else
                    position((3 + (z * 3)) + 1, 63)
                    bk_color(0)
                    puts(1, "   ")
                end if
                cursor(NO_CURSOR)
            end while
        elsif Lib[LIB_PROPS][z][PROP_TYPE] = CHOOSE_BOARD then
            n = GetBoard(1)
            position((3 + (z * 3)) + 1, 63)
            bk_color(1)
            if n = 0 then
                n = 1
            end if
            printf(1, "%3d", n)
            Object[1][OBJ_PROPS + (z - 1)] = n
        elsif Lib[LIB_PROPS][z][PROP_TYPE] = CHOOSE_CHAR then
            n = GetChar(0)
            position((3 + (z * 3)) + 1, 63)
            bk_color(1)
            if n = 0 then
                n = 1
            end if
            printf(1, "%3d", n)
            Object[1][OBJ_PROPS + (z - 1)] = n
        elsif Lib[LIB_PROPS][z][PROP_TYPE] = CHOOSE_COLOR then            
            ColorDialog()
            position((3 + (z * 3)) + 1, 63)
            text_color(CColorF)
            bk_color(CColorB)
            puts(1, 254)
            Object[1][OBJ_PROPS + (z - 1)] = n        
        end if
        position(3 + (z * 3), 63)
        text_color(14)
        bk_color(1)
        puts(1, Lib[LIB_PROPS][z][PROP_NAME] & " ")
    end for
    
    return Object
    
end function

global function ChooseFile(sequence Mask)
    -- example value for Ext: "*.zig"
    
    sequence RealDir, NDir, Chigger, n
    
    if sequence(dir(Mask)) then
        RealDir = dir(Mask)
        NDir = {}
        Chigger = {}
        for z = 1 to length(RealDir) do
            NDir = append(NDir, RealDir[z][1])
            Chigger = append(Chigger, "!" & num2str(z) & ";" & NDir[z])
        end for
        n = DisplayScroll("Select a file (ESC to cancel)", Chigger, 1)
        if length(n) != 0 then
            return NDir[str2num(n)]
        else return {1}
        end if
    else 
        n = DisplayScroll("Select a file (ESC to cancel)", {"(no files)"}, 1)
        return {1}
    end if
end function

